SystemOrganization addCategory: #'RemoteDebugger-Utilities'!

ByteArray variableByteSubclass: #RDBGIPAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:07'!
fromString: aString
	"return a new IP address from a string
	IPAddress fromString: '10.1.10.115'"
	
	^ self newFrom: ((aString findTokens: $.) collect: [:s | s asInteger])! !

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:03'!
local
	"mp 10/30/2005 15:53"
	"return a new IP address from a string
	IPAddress local"
	
	^ self newFrom: NetNameResolver localHostAddress! !

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:03'!
netID1: anInteger1 netID2: anInteger2 hostID1: anInteger3 hostID2: anInteger4
	"mp 10/6/2005 18:53"
	"Return an instance with the 4 bytes of an IP address
	IPAddress netID1: 10 netID2: 1 hostID1: 10 hostID2: 115"
	
	^ self 
		with: anInteger1
		with: anInteger2
		with: anInteger3
		with: anInteger4! !

!RDBGIPAddress methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:05'!
asString
	^ NetNameResolver stringFromAddress: self! !

!RDBGIPAddress methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:05'!
asSymbol
	^ self asString asSymbol! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID1
	"mp 10/6/2005 19:53"
	
	^ self third! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID1: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 3 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID2
	"mp 10/6/2005 19:53"
	
	^ self fourth! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID2: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 4 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID1
	"mp 10/6/2005 19:53"
	
	^ self first! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID1: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 1 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID2
	"mp 10/6/2005 19:53"
	
	^ self second! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID2: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 2 put: anInteger! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
next
	"mp 10/7/2005 14:57"
	
	self nextHostID2! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextHostID1
	"mp 12/19/2005 16:32"
	| gap |
	self hostID1 >= 255
		ifTrue: [gap := self hostID1 - 255.
			0
				to: gap
				do: [:n | self nextNetID2].
			self hostID1: gap]
		ifFalse: [self hostID1: self hostID1 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextHostID2
	"mp 12/19/2005 16:32"
	| gap |
	self hostID2 >= 255
		ifTrue: [gap := self hostID2 - 255.
			0
				to: gap
				do: [:n | self nextHostID1].
			self hostID2: gap]
		ifFalse: [self hostID2: self hostID2 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextNetID1
	"mp 12/19/2005 16:30"
	self netID1 >= 255
		ifTrue: [UTMaximumIPReached signal]
		ifFalse: [self netID1: self netID1 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextNetID2
	"mp 12/19/2005 16:32"
	| gap |
	self netID2 >= 255
		ifTrue: [gap := self netID2 - 255.
			0
				to: gap
				do: [:n | self nextNetID1].
			self netID2: gap]
		ifFalse: [self netID2: self netID2 + 1]! !

Object subclass: #RDBGHostID
	instanceVariableNames: 'hostname ipAddress port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGHostID class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:12'!
fromString: aString	
	^ self new fromString: aString! !

!RDBGHostID class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:59'!
hostname: aString ipAddress: anIP port: anInteger
	^ (self new) hostname: aString; ipAddress: anIP; port: anInteger.
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:13'!
= aHostID
	^ (self hostname = aHostID hostname) and:
		[(self ipAddress = aHostID ipAddress) and: 
			[self port = aHostID port]]! !

!RDBGHostID methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:00'!
asString
	^ self hostname, '@', self ipAddress asString, ':', self port asString! !

!RDBGHostID methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:15'!
asStringID
	^ self ipAddress asString , ':' , self port asString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:13'!
fromString: aString 
	| tokens |
	tokens := aString findTokens: '@:'.
	self hostname: tokens first.
	self ipAddress: (RDBGIPAddress fromString: tokens second).
	self port: tokens third asInteger
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:15'!
hash
	^ self hostname hash bitXor: 
		(self ipAddress hash bitXor: self port hash).
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:14'!
hostAtIP
	"return a string in the form 'host@127.0.0.1'"
	
	^ self hostname , '@' , self ipAddress asString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
hostname
	^hostname! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
hostname: aString
	hostname := aString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
ipAddress
	^ipAddress! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:06'!
ipAddress: anIPAddress
	ipAddress := anIPAddress! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:02'!
port
	^port! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:02'!
port: anInteger
	port := anInteger! !
